#include <Wire.h>
#include <LCD.h>
#include <LiquidCrystal_I2C.h>
#include "DHT.h"

//                     Addr, En, Rw, Rs, d4, d5, d6, d7, backlighpin, polarity
LiquidCrystal_I2C lcd( 0x27, 2,   1,  0,  4,  5,  6,  7,           3, POSITIVE );

#define DHTPIN 2     // Pin del Arduino al cual esta conectado el pin 2 del sensor

// Descomentar segun el tipo de sensor DHT usado
#define DHTTYPE DHT11   // DHT 11 

unsigned long tAntes = 0;
unsigned long tAhora = 0;
unsigned long tEjecucion = 1000;


int Valor; 

int porcentaje; 

DHT dht(DHTPIN, DHTTYPE);


void setup()
{
  Serial.begin(9600);
  
  //Serial.println("Failed to configure Ethernet using DHCP");
  //Valor = analogRead(1);  
  //Serial.print(Valor);
    
  lcd.begin(16,2);
  lcd.backlight();

  //lcd.setCursor(0,0);
  //lcd.print("Tiempo");  

  dht.begin();
  
}


void loop()
{
  
  Valor = analogRead(1);  
 //  Serial.print(Valor);
 // tAhora = millis();

//  if( tAhora - tAntes >= tEjecucion )
//  {
 //   tAntes = tAhora;

  //  lcd.setCursor(0,1);
  //  lcd.print(tAhora/1000);
 // }
  porcentaje =map(Valor-1023, 0, 1023, 0, 100);  // convertir a porcentaje
  porcentaje= porcentaje*-1;
  if (Valor <= 300) { 
   Serial.println(" Encharcado"); 
    lcd.setCursor(0,0);
    lcd.print("Humedad :");
    lcd.print(porcentaje);
     lcd.print("%     ");
    
    lcd.setCursor(0,1);
    lcd.print("Encharcado");
  }
     
if ((Valor > 300) and (Valor <= 700)) { 
    Serial.println(" Humedo, no regar");

       lcd.setCursor(0,0);
    lcd.print("Humedad :");
    lcd.print(porcentaje);
     lcd.print("%     ");
    
    lcd.setCursor(0,1);
    lcd.print("Humedo, no regar");
}
if (Valor > 700) { 
    Serial.println(" Seco, necesitas regar"); 
     lcd.setCursor(0,0);
    lcd.print("Humedad :");
    lcd.print(porcentaje);
     lcd.print("%     ");
    
    lcd.setCursor(0,1);
    lcd.print("Seco, necesitas regar"); 
}
delay(4000);

float h = dht.readHumidity();
  // Obtiene la Temperatura en Celsius
  float t = dht.readTemperature();
  
  // Control de errores, valida que se obtuvieron valores para los datos medidos
  if (isnan(h) || isnan(t)) {
    Serial.println("Falla al leer el sensor DHT!");
    return;
  }

  Serial.print("Humedad: "); 
  Serial.print(h);
  Serial.print(" %\t");
  Serial.print("Temperatura: "); 
  Serial.print(t);
  Serial.println("*C ");

   lcd.setCursor(0,0);
    lcd.print("Humed Amb:");
    lcd.print(h);
     lcd.print("%");
    
    lcd.setCursor(0,1);
    lcd.print("Temp : ");
   lcd.print(t);
  lcd.print(" C ");
  delay(4000);
  
 lcd.setCursor(0,0);
    lcd.print("SomosMakers.cl   ");
    lcd.setCursor(0,1);
    lcd.print("                  ");
    delay(4000);
}